<html>

<!--
  BrameldProcessor4.jsp
  updated by JMH on October 22, 2002 at 09:10 AM

  for use with Brameld Multipart Form Data Processor
  
  Reference:  http://users.boone.net/wbrameld/multipartformdata/
    Javadoc:  http://users.boone.net/wbrameld/multipartformdata/docs-1.4/com/bigfoot/bugar/servlet/http/MultipartFormData.html
     Author:  Walter Brameld, wbrameld4@yahoo.com
-->

<head>
  <meta name=""Author" content="Jesse M. Heines">
  <script type="text/javascript" src="../common.js"></script>

  <title>UML GUI File Upload Results</title>
  <script type="text/javascript">
    // the following causes an "access denied" error if the upload form is run
    //    within frames on one system (teaching.cs.uml.edu) and this JSP is run 
    //    on another system (weblabpc4.cs.uml.edu)
    // parent.document.title = document.title ;
    document.title = document.title ;
  </script>

  <link rel="stylesheet" type="text/css" href="../blueverdana.css">
  
  <%-- 
    classpath root for .class files is ~heines/public_html/WEB-INF/classes
    see http://jakarta.apache.org/tomcat/tomcat-4.0-doc/class-loader-howto.html
    therefore, subdirectory com must be created in the WEB-INF/classes directory
      for the following import to work
  --%>
  <%@ page language="java"
           import="java.io.*, java.util.*, com.bigfoot.bugar.servlet.http.*"
  %>
  
  <%@ include file="../common-jspfns.jsp" %>

  <%!
    // Note:  Do not initialize member variables here.  Doing so causes them not
    // to be reinitialized when the JSP is run repeatedly.  This is, they function
    // lick static variables.
  
    /** name of user to store data for */
    private String strUserName ;
    
    /** name of the file to write (no path allowed) */
    private String strFileName ;
    
    /** path to write file to */
    private String strFilePath ;
  
    /** path to file to upload on user's system */
    private String strFullUploadedFilePath ;

    /** response to return to caller */
    private String strResponse ;
    
    /** error message, if any */
    String strErrorMessage ;
    
    /** base for student uploads */
    private String strBase ;
    
    /** base that student uses to access his/her uploaded files */
    private String strBaseURL ;
    
    /** path to user file on server under his/her base path */
    String strUserPath ;

    /** boolean to indicate whether student wishes to overwrite an existing file */
    private boolean bOverwrite ;
    
    /** Bugar's Multipart Form Data object */
    MultipartFormData multipart ;
  %>
  
  <%
    // initialize response to send back to user (do this here so that it is 
    // reinitialized in each run)
    strResponse = "" ;
    strResponse += "<p>" + (new Date()).toString() + "</p>" ;
    strErrorMessage = "<i>Error:</i>&nbsp; " ;

    // instantiate a MultipartFormData object for this request
    // JMH: note that this statement does the actual upload 
    //      on Windows, the upload is to Tomcat's tmp directory
    //      on Linux, the upload is to the system tmp directory (/tmp)
    //      the file name there is of the form multipartdatabeanNNNNN.tmp
    multipart = new MultipartFormData( request ) ;
    if ( multipart == null )
      strErrorMessage += "MultipartFormData object instantiation failed" ;
    

    //// get passed parameters
    
    // get submitter name
    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
    {
      strUserName = multipart.getParameter( "submitter" ) ;
      if ( strUserName == null || strUserName.equals( "" ) )
        strErrorMessage += "User name not supplied." ;
    }

    // get full path on user's system of file to upload and extract file name
    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
    {
      strFullUploadedFilePath = multipart.getFileName( "fileUpload" ) ;
      if ( strFullUploadedFilePath == null || strFullUploadedFilePath.equals( "" ) )
        strErrorMessage += "File to upload not supplied." ;
      else
      {
        strFileName = strFullUploadedFilePath.substring( 
                          strFullUploadedFilePath.lastIndexOf( "/" ) + 1 ) ;
        if ( strFileName.equals( strFullUploadedFilePath ) )
          strFileName = strFullUploadedFilePath.substring( 
                            strFullUploadedFilePath.lastIndexOf( "\\" ) + 1 ) ;
      }
    }
    
    // get optional file path
    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
      strFilePath = multipart.getParameter( "filePath" ) ;

    // get overwrite flag (not used in BugarProcessor3.jsp)
    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
    {
      bOverwrite = true ;   // set default
      if ( multipart.getParameter( "bOverwrite" ) != null )
        bOverwrite = multipart.getParameter( "bOverwrite" ).equals( "yes" ) ;
    }

    // initialize the location of this student's uploads
    if ( System.getProperty( "os.name" ).equals( "Windows 2000" ) )
      strBase = "C:\\StudentUploads\\" + strUserName + "\\"  ;
    else if ( System.getProperty( "os.name" ).equals( "Linux" ) )
      strBase = "/opt/JRun/servers/default/students/" + strUserName + "/" ;
    else if ( System.getProperty( "os.name" ).equals( "Windows NT" ) )
      strBase = "E:\\StudentUploads\\" + strUserName + "\\"  ;

    strBaseURL = "http://" + request.getServerName() + "/students/" + 
          strUserName + "/" ;
    
    //// create path to output directory
    //// note that this directory must exist before moving the temp file to it
    
    strUserPath = "" ;   // path to user file on server

    // clean file path specified by user
    strFilePath = strFilePath.trim() ;
    while ( strFilePath.startsWith( "/" ) )
      strFilePath = strFilePath.substring( 1 ) ;
    while ( strFilePath.endsWith( "/" ) )
      strFilePath = strFilePath.substring( 0, strFilePath.length()-1 ) ;
    
    // parse file path
    StringTokenizer st = new StringTokenizer( strFilePath, "/" ) ;
    while ( st.hasMoreTokens() )
    {
      if ( System.getProperty( "os.name" ).equals( "Windows 2000" ) || 
           System.getProperty( "os.name" ).equals( "Windows NT" ) )
        strUserPath += st.nextToken() + "\\" ;
      else if ( System.getProperty( "os.name" ).equals( "Linux" ) )
        strUserPath += st.nextToken() + "/" ;
    }
    if ( strUserPath != null && strUserPath.length() > 0 && 
         strUserPath.charAt( strUserPath.length()-1 ) != '/' && 
         strUserPath.charAt( strUserPath.length()-1 ) != '\\' )
    {
      if ( System.getProperty( "os.name" ).equals( "Windows 2000" ) )
        strUserPath += st.nextToken() + "\\" ;
      else if ( System.getProperty( "os.name" ).equals( "Linux" ) )
        strUserPath += st.nextToken() + "/" ;
    }
    
    // set the path specified by the user, creating it if it does not exist
    File filePath = new File( strBase, strUserPath ) ;
    if ( ! filePath.exists() ) 
      if ( ! filePath.mkdirs() )
      {
        strResponse += "Unable to create directory " ; 
        strResponse += strBaseURL ;
        if ( strFilePath != null && strFilePath.length() > 0 )
            strResponse += strFilePath + "/" ;
      }                 
    
    //// move uploaded file to desired directory
    
    // the following code, which is from the original example by Brameld, works 
    //    fine with the Apache server under Windows, but not with the JRun server 
    //    under Linux
    // File newName = new File( strBase + strUserPath, strFileName );
    // new File( multipart.getLocalPath( "fileUpload" ) ).renameTo( newName );
    //
    // I have therefore implemented the following code to do the copy manually.

    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
    {
      //// character stream version
      
      // File fileIn = new File( multipart.getLocalPath( "fileUpload" ) ) ;
      // BufferedReader buffIn = new BufferedReader( new FileReader( fileIn ) ) ;
      // File fileOut = new File( strBase + strUserPath, strFileName ) ;
      // PrintWriter pwOut = new PrintWriter( new FileOutputStream( fileOut ) ) ;
      // String str = null ;
      // while ( ( str = buffIn.readLine() ) != null )
      //   pwOut.println( str ) ;
      // pwOut.close() ;
      // buffIn.close() ;
      
      //// byte stream version
      
      File fileIn = new File( multipart.getLocalPath( "fileUpload" ) ) ;
      FileInputStream fisIn = new FileInputStream( fileIn ) ;
      File fileOut = new File( strBase + strUserPath, strFileName ) ;
      FileOutputStream fosOut = new FileOutputStream( fileOut ) ;
      int byteIn = 0 ;
      while ( ( byteIn = fisIn.read() ) != -1 )
        fosOut.write( byteIn ) ;
      fosOut.close() ;
      fisIn.close() ;
    }
    
    //// construct response to send to user

    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
    {
      String strFileURL = strBaseURL + 
                          ( strFilePath.length() > 0 ? strFilePath + "/" : "" ) + 
                          strFileName ;
      strResponse += "Your file:<br/>" +
                     "<code>&nbsp;&nbsp; <b>" + strFullUploadedFilePath + 
                        "</b></code><br/>" +
                     "was uploaded to:<br/>" +
                     "<code>&nbsp;&nbsp; <b>" + 
                     "<a href=\"" + strFileURL + "\">" + strFileURL + 
                        "</a></b></code>" ;
      strResponse += "</p><p>All files you have uploaded may be viewed by starting at:<br/>" +
                     "<code>&nbsp;&nbsp; <b>" + 
                     "<a href=\"" + strBaseURL + "\">" + strBaseURL + 
                        "</a></b></code>" ;
    }
    else
      strResponse = strErrorMessage ;
  %>
</head>

<body bgcolor="#FFFFFF">

<script>
  document.writeln( "<h2>" + document.title + "</h2>" ) ;
</script>

<p><%= strResponse %></p>
  
<%--  original Brameld code

  <p>
    The following parameters were posted with the form:
    <table border="1" cellspacing="0">
      <%
        Enumeration paramNames = multipart.getParameterNames() ;
        while ( paramNames.hasMoreElements() ) 
        {
          String   name   = (String) paramNames.nextElement() ;
          String[] values = multipart.getParameterValues( name ) ;
          out.println( "<tr>" ) ;
          out.println( "  <td style=\"font-style: italic\">" + name + "</td>" ) ;
          out.print  ( "  <td>&nbsp;" ) ;
            for ( int i = 0;  i < values.length;  ++i ) 
              out.print( values[i] ) ;
          out.println( "&nbsp;</td>" ) ;
          out.println( "</tr>" ) ;
        }
      % >
    </table>
  </p>
  
  <p>
    The following files were uploaded with the form:
    <table border="1" cellspacing="0">
      <%
        Enumeration fieldNames = multipart.getFileFormFields() ;
        while ( fieldNames.hasMoreElements() ) 
        {
          String   field  = (String) fieldNames.nextElement();
          String[] names  = multipart.getFileNameValues(  field ) ;  // name );
          long[]   sizes  = multipart.getFileSizeValues(  field ) ;  // name );
          String[] types  = multipart.getFileTypeValues(  field ) ;  // name );
          String[] locals = multipart.getLocalPathValues( field ) ;  // name );
          
          out.println( "<tr><td style=\"font-style: italic\">Form Field</td><td>&nbsp;" + field     + "&nbsp;</td></tr>" ) ;
          out.println( "<tr><td style=\"font-style: italic\">File Path </td><td>&nbsp;" + names[0]  + "&nbsp;</td></tr>" ) ;
          out.println( "<tr><td style=\"font-style: italic\">File Size </td><td>&nbsp;" + sizes[0]  + "&nbsp;</td></tr>" ) ;
          out.println( "<tr><td style=\"font-style: italic\">File Type </td><td>&nbsp;" + types[0]  + "&nbsp;</td></tr>" ) ;
          out.println( "<tr><td style=\"font-style: italic\">Local Copy</td><td>&nbsp;" + locals[0] + "&nbsp;</td></tr>" ) ;
  
          // out.println( "<tr><td>&nbsp;</td><td>&nbsp;</td></tr>" ) ;
        }
      % >
    </table>
  </p>

--%>

  <%
    // clean up (by deleting temp files)
    multipart.cleanUp() ;
  %>

  <script type="text/javascript">
    // show standard document information
    showLastModifiedDate( document ) ;
  </script>
  
  <a href="javascript:history.back()">
  <p><img src="../images/blue_prev.gif" alt="Back" border="2"
  align="center" width="24" height="24">&nbsp;Back to Previous Page</p></a>

</body>  <!-- moved this to after cleanUp() -->
</html>
