<%--
 *  File: umlguiStoreXML9.jsp
 *  Reference:  Hall & Brown, pp. 1075
 *  
 *  @author  Jesse M. heines, heines@cs.uml.edu
 *  @version 1.9, updated by JMH on October 04, 2002 at 07:57 PM
--%>

<%@page import="java.io.*"     %>   <%-- for ObjectInputStream        --%>
<%@page import="java.util.*"   %>   <%-- for StringTokenizer          --%>

<%@page import="java.awt.*"    %>   <%-- for base of Swing components --%>
<%@page import="javax.swing.*" %>   <%-- for JOptionPane              --%>


<%!
  // Note:  Do not initialize member variables here.  Doing so causes them not
  // to be reinitialized when the JSP is run repeatedly.  This is, they function
  // like static variables.

  /** the XML document as a string */
  private String strDocument ;
  
  /** name of user to store data for */
  private String strUserName ;
  
  /** name of the file to write (no path allowed) */
  private String strFileName ;
  
  /** path to write file to */
  private String strFilePath ;

  /** response to return to caller */
  private String strResponse ;
  
  /** base for student uploads */
  private String strBase ;
  
  /** base that student uses to access his/her uploaded files */
  private String strBaseURL ;
%>
<%
  // initialize response to send back to user (do this here so that it is 
  // reinitialized in each run)
  strResponse = "" ;

  // Step 0 - read incoming data
  ObjectInputStream oisIn = null ;
  try {
    oisIn = new ObjectInputStream( request.getInputStream() ) ;
  } catch ( IOException ioe ) {
      strResponse = "IOException at Step 0 in umlguiStoreXML6 JSP " +
          "method umlguiStoreXML:\n" + ioe.toString() ;
  }

  try {
    // Hall & Brown, p. 1074, Step 6
    strUserName = (String) oisIn.readObject() ;
    strFileName = (String) oisIn.readObject() ;
    strFilePath = (String) oisIn.readObject() ;
    strDocument = (String) oisIn.readObject() ;
    // p. 1074 Step 7
    oisIn.close() ;
  } catch ( ClassNotFoundException cnfe ) {
    strResponse = "ClassNotFoundException at Step 6 in umlguiStoreXML:\n" + 
        cnfe.toString() ;
  } catch ( IOException ioe ) {
    strResponse = "IOException at Step 6 in umlguiStoreXML:\n" + 
        ioe.toString() ;
  }

  // initialize location of this student's uploads
  if ( System.getProperty( "os.name" ).equals( "Windows 2000" ) )
  {
    strBase = "C:\\StudentUploads\\" + strUserName + "\\"  ;
    strBaseURL = "http://" + request.getServerName() + "/students/" + 
          strUserName + "/" ;
  }
  else if ( System.getProperty( "os.name" ).equals( "Linux" ) )
  {
    strBase = "/opt/JRun/servers/default/students/" + strUserName + "/" ;
    strBaseURL = "http://" + request.getServerName() + "/students/" + 
          strUserName + "/" ;
  }
  
  // declare variables for file writing
  String strUserPath = "" ;            // path to user file on server
  File filePath = null ;               // File object representing directory path
  File fileXML = null ;                // File object representing XML file
  FileOutputStream fosStream = null ;  // for writing XML file
  PrintWriter pwWriter = null ;        // for writing XML file
  String strException = "" ;           // exception 

  // if no error at this point, try to write the user's file
  if ( strResponse.length() == 0 )
  {
    StringTokenizer st = new StringTokenizer( strFilePath, "/" ) ;
    while ( st.hasMoreTokens() )
    {
      if ( System.getProperty( "os.name" ).equals( "Windows 2000" ) )
        strUserPath += st.nextToken() + "\\" ;
      else if ( System.getProperty( "os.name" ).equals( "Linux" ) )
        strUserPath += st.nextToken() + "/" ;
    }
    
    // set the path specified by the user, creating it if it does not exist
    filePath = new File( strBase, strUserPath ) ;
    if ( ! filePath.exists() ) 
      if ( ! filePath.mkdirs() )
      {
        strResponse += "Unable to create directory " ; 
        strResponse += strBaseURL ;
        if ( strFilePath != null && strFilePath.length() > 0 )
            strResponse += strFilePath + "/" ;
      }                 

    // if no error at this point ...
    // set the file specified by the user, creating it if it does not exist
    if ( strResponse.length() == 0 )
    {
      fileXML = new File( filePath, strFileName ) ;
      try {
        fosStream = new FileOutputStream ( fileXML ) ;
      } catch ( FileNotFoundException fnfe ) {
        strException += fnfe.toString() ;
      } catch ( SecurityException se ) {
        strException += se.toString() ;
      }      
    }
    
    // if no error at this point ...
    // create a PrintWriter from the FileOutputStream and write the file
    if ( strException.length() == 0 )
    {
      pwWriter = new PrintWriter( fosStream ) ;
      pwWriter.print( strDocument ) ;
      pwWriter.close() ;
    }

    // if no error at this point ...
    // construct the URL to the created file to return to the user as the 
    //    response
    if ( strException.length() == 0 )
    {
      strResponse += strBaseURL ;
      if ( strFilePath != null && strFilePath.length() > 0 )
          strResponse += strFilePath + "/" ;
      strResponse += strFileName ;
    }
    // otherwise, return the exception
    else
    {
      strResponse = "Exception: " + strException ;
    }
  }
  
  // send the response to the user
  out.println( strResponse ) ;
%>
