<html>

<!--
  BrameldProcessor4.jsp
  updated by JMH on October 22, 2002 at 09:10 AM

  for use with Brameld Multipart Form Data Processor
  
  Reference:  http://users.boone.net/wbrameld/multipartformdata/
    Javadoc:  http://users.boone.net/wbrameld/multipartformdata/docs-1.4/com/bigfoot/bugar/servlet/http/MultipartFormData.html
     Author:  Walter Brameld, wbrameld4@yahoo.com
-->

<head>
  <meta name=""Author" content="Jesse M. Heines">
  <script type="text/javascript" src="../common.js"></script>

  <title>UML GUI File Deletion Results</title>
  <script type="text/javascript">
    // the following causes an "access denied" error if the upload form is run
    //    within frames on one system (teaching.cs.uml.edu) and this JSP is run 
    //    on another system (weblabpc4.cs.uml.edu)
    // parent.document.title = document.title ;
    document.title = document.title ;
  </script>

  <link rel="stylesheet" type="text/css" href="../blueverdana.css">
  
  <%-- 
    classpath root for .class files is ~heines/public_html/WEB-INF/classes
    see http://jakarta.apache.org/tomcat/tomcat-4.0-doc/class-loader-howto.html
    therefore, subdirectory com must be created in the WEB-INF/classes directory
      for the following import to work
  --%>
  <%@ page language="java"
           import="java.io.*, java.util.*, com.bigfoot.bugar.servlet.http.*"
  %>
  
  <%@ include file="../common-jspfns.jsp" %>

  <%!
    // Note:  Do not initialize member variables here.  Doing so causes them not
    // to be reinitialized when the JSP is run repeatedly.  This is, they function
    // lick static variables.
  
    /** name of user to store data for */
    private String strUserName ;
    
    /** name of the file to write (no path allowed) */
    private String strFileName ;
    
    /** path to write file to */
    private String strFilePath ;
  
    /** path to file to upload on user's system */
    private String strFullUploadedFilePath ;

    /** response to return to caller */
    private String strResponse ;
    
    /** error message, if any */
    String strErrorMessage ;
    
    /** base for student uploads */
    private String strBase ;
    
    /** base that student uses to access his/her uploaded files */
    private String strBaseURL ;
    
    /** path to user file on server under his/her base path */
    String strUserPath ;
    
    /** full URL to file specified by the user */
    String strFileURL ;

    /** boolean to indicate whether student wishes to overwrite an existing file */
    private boolean bOverwrite ;
    
    /** Bugar's Multipart Form Data object */
    MultipartFormData multipart ;
  %>
  
  <%
    // initialize response to send back to user (do this here so that it is 
    // reinitialized in each run)
    strResponse = "" ;
    strResponse += "<p>" + (new Date()).toString() + "</p>" ;
    strErrorMessage = "<i>Error:</i>&nbsp; " ;


    //// get passed parameters
    
    // get submitter name
    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
    {
      strUserName = request.getParameter( "submitter" ) ;
      if ( strUserName == null || strUserName.equals( "" ) )
        strErrorMessage += "User name not supplied." ;
    }

    // get file name
    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
    {
      strFileName = request.getParameter( "fileToDelete" ) ;
      if ( strFileName == null || strFileName.equals( "" ) )
        strErrorMessage += "File name not supplied." ;
    }

    // get optional file path
    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
      strFilePath = request.getParameter( "filePath" ) ;

    // initialize the location of this student's uploads
    if ( System.getProperty( "os.name" ).equals( "Windows 2000" ) )
      strBase = "C:\\StudentUploads\\" + strUserName + "\\"  ;
    else if ( System.getProperty( "os.name" ).equals( "Linux" ) )
      strBase = "/opt/JRun/servers/default/students/" + strUserName + "/" ;
    else if ( System.getProperty( "os.name" ).equals( "Windows NT" ) )
      strBase = "E:\\StudentUploads\\" + strUserName + "\\"  ;

    strBaseURL = "http://" + request.getServerName() + "/students/" + 
          strUserName + "/" ;
    

    //// create path to output directory
    //// note that this directory must exist before moving the temp file to it
    
    strUserPath = "" ;   // path to user file on server

    // clean file path specified by user
    strFilePath = strFilePath.trim() ;
    while ( strFilePath.startsWith( "/" ) )
      strFilePath = strFilePath.substring( 1 ) ;
    while ( strFilePath.endsWith( "/" ) )
      strFilePath = strFilePath.substring( 0, strFilePath.length()-1 ) ;
    
    // parse file path
    StringTokenizer st = new StringTokenizer( strFilePath, "/" ) ;
    while ( st.hasMoreTokens() )
    {
      if ( System.getProperty( "os.name" ).equals( "Windows 2000" ) || 
           System.getProperty( "os.name" ).equals( "Windows NT" ) )
        strUserPath += st.nextToken() + "\\" ;
      else if ( System.getProperty( "os.name" ).equals( "Linux" ) )
        strUserPath += st.nextToken() + "/" ;
    }
    if ( strUserPath != null && strUserPath.length() > 0 && 
         strUserPath.charAt( strUserPath.length()-1 ) != '/' && 
         strUserPath.charAt( strUserPath.length()-1 ) != '\\' )
    {
      if ( System.getProperty( "os.name" ).equals( "Windows 2000" ) )
        strUserPath += st.nextToken() + "\\" ;
      else if ( System.getProperty( "os.name" ).equals( "Linux" ) )
        strUserPath += st.nextToken() + "/" ;
    }
    
 
    //// delete file specified by the user
    
    // test whether the file exists
    String strFileURL = strBaseURL + 
                        ( strFilePath.length() > 0 ? strFilePath + "/" : "" ) + 
                        strFileName ;

    File fileToDelete = new File( strBase + strUserPath, strFileName ) ;
    if ( ! fileToDelete.exists() ) 
      strErrorMessage += "File<code> <b>" + strFileURL + "</b> </code>does not exist." ;

    // delete the uploaded file
    boolean bResult = false ;
    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
      if ( ! ( bResult = fileToDelete.delete() ) )
      {
        strErrorMessage += "Unable to delete file<code> <b>" + strFileURL + "</b></code>." ;
        if ( fileToDelete.isDirectory() )
        {
          String[] directory = fileToDelete.list() ;
          if ( directory.length > 0 )
          {
            strErrorMessage += "</p><p>This file is a directory and contains the following files:" ;
            for ( int k = 0 ; k < directory.length ; k++ )
            {
              strErrorMessage += "<br/><code>&nbsp;&nbsp;&nbsp;" + directory[ k ] + "</code>" ;
              File fileSubDir = new File( strBase + strUserPath + "/" + strFileName, directory[ k ] ) ;
              if ( fileSubDir.isDirectory() )
                strErrorMessage += "&nbsp;&nbsp;&lt;<i>directory</i>&gt;" ;
            }
          }
          else
            strErrorMessage += "</p><p>This file is a directory and may be in use or may not be empty." ;
        }
      }
    

    //// construct response to send to user

    if ( strErrorMessage.equals( "<i>Error:</i>&nbsp; " ) )
    {
      strResponse += "Your file:<br/>" +
                     "<code>&nbsp;&nbsp; <b>" + strFileURL + "</b></code><br/>" +
                     "was sucessfully deleted." ;
      strResponse += "</p><p>All files you have uploaded may be viewed by starting at:<br/>" +
                     "<code>&nbsp;&nbsp; <b>" + 
                     "<a href=\"" + strBaseURL + "\">" + strBaseURL + 
                        "</a></b></code>" ;
    }
    else
      strResponse = strErrorMessage ;
  %>
</head>

<body bgcolor="#FFFFFF">

<script>
  document.writeln( "<h2>" + document.title + "</h2>" ) ;
</script>

<p><%= strResponse %></p>
  
  <script type="text/javascript">
    // show standard document information
    showLastModifiedDate( document ) ;
  </script>
  
  <a href="javascript:history.back()">
  <p><img src="../images/blue_prev.gif" alt="Back" border="2"
  align="center" width="24" height="24">&nbsp;Back to Previous Page</p></a>

</body>  <!-- moved this to after cleanUp() -->
</html>
